﻿local L = AceLibrary("AceLocale-2.2"):new("GridStatusMending")
local BS = LibStub("LibBabble-Spell-3.0"):GetLookupTable()

local MendingName = BS["Mending"]

GridStatusMending = GridStatus:NewModule("GridStatusMending")
GridStatusMending.menuName = MendingName

L:RegisterTranslations("enUS", function()
	return {
		["Mending Stack"] = true,
		["Mending Duration"] = true,

		["Color 1"] = true,
		["Color 2"] = true,
		["Color 3"] = true,
		["Color 4"] = true,
		["Color 5"] = true,

		["Color when player has one counter of mending."] = true,
		["Color when player has two counters of mending."] = true,
		["Color when player has three counters of mending."] = true,
		["Color when player has four counters of mending."] = true,
		["Color when player has five counters of mending."] = true,
		
		["Global Cooldown Mode"] = true,
		["Global Cooldown Duration"] = true,
		["Global Cooldown Delay"] = true,
	}
end)

GridStatusMending.defaultDB = {
	debug = false,
	alert_MendingStack = {
		text = L["Mending Stack"],
		enable = true,
		color = { r = 0, g = 1, b = 1, a = 1 },
		color2 = { r = .5, g = .75, b = 0, a = 1 },
		color3 = { r = 1, g = .5, b = 0, a = 1 },
		color4 = { r = 1, g = 1, b = 0, a = 1 },
		color5 = { r = 1, g = 0, b = 0, a = 1 },
		gcdMode = false,
		gcdDuration = 1.5,
		gcdDelay = 0.5,
		priority = 70,
		range = false,
	},
	alert_MendingDuration = {
		text = L["Mending Duration"],
		enable = true,
		color = { r = 1, g = 1, b = 0, a = 1 },
		color2 = { r = 0, g = 1, b = 1, a = 1 },
		color3 = { r = 0, g = 1, b = 0, a = 1 },
		color4 = { r = 0, g = 1, b = 0, a = 1 },
		color5 = { r = 0, g = 1, b = 0, a = 1 },
		priority = 70,
		range = false,
	},
}

local alert_MendingStackOptions = {
	["color2"] = {
		type = "color",
		order = 100,
		name = L["Color 2"],
		desc = L["Color when player has two counters of mending."],
		hasAlpha = true,
		get = function ()
			local color = GridStatusMending.db.profile.alert_MendingStack.color2
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusMending.db.profile.alert_MendingStack.color2
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["color3"] = {
		type = "color",
		order = 101,
		name = L["Color 3"],
		desc = L["Color when player has three counters of mending."],
		hasAlpha = true,
		get = function ()
			local color = GridStatusMending.db.profile.alert_MendingStack.color3
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusMending.db.profile.alert_MendingStack.color3
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["color4"] = {
		type = "color",
		order = 101,
		name = L["Color 4"],
		desc = L["Color when player has four counters of mending."],
		hasAlpha = true,
		get = function ()
			local color = GridStatusMending.db.profile.alert_MendingStack.color4
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusMending.db.profile.alert_MendingStack.color4
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["color5"] = {
		type = "color",
		order = 101,
		name = L["Color 5"],
		desc = L["Color when player has five counters of mending."],
		hasAlpha = true,
		get = function ()
			local color = GridStatusMending.db.profile.alert_MendingStack.color5
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusMending.db.profile.alert_MendingStack.color5
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
}

local alert_MendingDurationOptions = {
	["color2"] = {
		type = "color",
		order = 100,
		name = L["Color 2"],
		desc = L["Color when player has two counters of mending."],
		hasAlpha = true,
		get = function ()
			local color = GridStatusMending.db.profile.alert_MendingDuration.color2
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusMending.db.profile.alert_MendingDuration.color2
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["color3"] = {
		type = "color",
		order = 101,
		name = L["Color 3"],
		desc = L["Color when player has three counters of mending."],
		hasAlpha = true,
		get = function ()
			local color = GridStatusMending.db.profile.alert_MendingDuration.color3
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusMending.db.profile.alert_MendingDuration.color3
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["color4"] = {
		type = "color",
		order = 101,
		name = L["Color 4"],
		desc = L["Color when player has four counters of mending."],
		hasAlpha = true,
		get = function ()
			local color = GridStatusMending.db.profile.alert_MendingDuration.color4
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusMending.db.profile.alert_MendingDuration.color4
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["color5"] = {
		type = "color",
		order = 101,
		name = L["Color 5"],
		desc = L["Color when player has five counters of mending."],
		hasAlpha = true,
		get = function ()
			local color = GridStatusMending.db.profile.alert_MendingDuration.color5
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusMending.db.profile.alert_MendingDuration.color5
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["gcdMode"] = {
		type = "toggle",
		order = 102,
		name = L["Global Cooldown Mode"],
		desc = L["Global Cooldown Mode"]..".",
		get = function ()
			return GridStatusMending.db.profile.alert_MendingStack.gcdMode
		end,
		set = function (arg)
			GridStatusMending.db.profile.alert_MendingStack.gcdMode = arg
		end,
	},
	["gcdDuration"] = {
		type = "range",
		order = 103,
		name = L["Global Cooldown Duration"],
		desc = L["Global Cooldown Duration"]..".",
		min = 1.5,
		max = 2,
		step = 0.01,
		disabled = function()
			if GridStatusMending.db.profile.alert_MendingStack.gcdMode then
				return false
			else
				return true
			end
		end,
		get = function ()
			return GridStatusMending.db.profile.alert_MendingStack.gcdDuration
		end,
		set = function (arg)
			GridStatusMending.db.profile.alert_MendingStack.gcdDuration = arg
		end,
	},
	["gcdDelay"] = {
		type = "range",
		order = 104,
		name = L["Global Cooldown Delay"],
		desc = L["Global Cooldown Delay"]..".",
		min = 0,
		max = 1,
		step = 0.01,
		disabled = function()
			if GridStatusMending.db.profile.alert_MendingStack.gcdMode then
				return false
			else
				return true
			end
		end,
		get = function ()
			return GridStatusMending.db.profile.alert_MendingStack.gcdDelay
		end,
		set = function (arg)
			GridStatusMending.db.profile.alert_MendingStack.gcdDelay = arg
		end,
	}
}

function GridStatusMending:OnInitialize()
	self.super.OnInitialize(self)
	self:RegisterStatus("alert_MendingStack", L["Mending Stack"], alert_MendingStackOptions)
	self:RegisterStatus("alert_MendingDuration", L["Mending Duration"], alert_MendingDurationOptions)
end

function GridStatusMending:OnEnable()
	local f = function()
		GridStatusMending:UpdateAllUnits("player")
	end
	self:RegisterEvent("SpecialEvents_UnitBuffGained")
	self:RegisterEvent("SpecialEvents_UnitBuffLost")
	self:RegisterEvent("SpecialEvents_UnitBuffCountChanged")
	self:RegisterEvent("Grid_UnitJoined")
	self:RegisterEvent("Grid_UnitDeath")
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "UpdateAllUnits")
	self:ScheduleRepeatingEvent("GridMending_Refresh", f, 0.07)
end

function GridStatusMending:Reset()
	self.super.Reset(self)
	self:UpdateAllUnits()
end

function GridStatusMending:UpdateAllUnits()
	local name, status, statusTbl

	for name, status, statusTbl in self.core:CachedStatusIterator("alert_MendingStack") do
		self:UpdateUnit(name,true)
	end
end

function GridStatusMending:Grid_UnitJoined(name, unitid)
	if unitid then
		self:UpdateUnit(unitid)
	end
end

function GridStatusMending:Grid_UnitDeath(unitname)
	local status, moduleName, desc
	for status, moduleName, desc in self.core:RegisteredStatusIterator() do
		if moduleName == self.name then
			self.core:SendStatusLost(unitname, status)
		end
	end
end

function GridStatusMending:CountHOTs(unitid)
	local maxbuffs = 40
	if unitid then
		for i = 1, maxbuffs do
			buffName, rank, texture, applications, duration, timeleft = UnitBuff(unitid,i,true)
			if buffName and timeleft then
				if self:isMending(buffName) then
					return applications, timeleft
				end
			end
		end
	end
	return 0,0
end

function GridStatusMending:SpecialEvents_UnitBuffGained(unit, buff, index, apps, tex, rank)
	--self:UpdateUnit(unit,true)
	self:Debug("UnitBuffGained:"..buff)
	if self:isMending( buff ) then
		self:UpdateUnit(unit, true)
	end
end

function GridStatusMending:SpecialEvents_UnitBuffLost(unit, buff, index, apps, tex, rank)
	self:Debug("UnitBuffLost:"..buff)
	if self:isMending( buff ) then
		self:UpdateUnit(unit, true)
	end
end

function GridStatusMending:SpecialEvents_UnitBuffCountChanged(unit, buff, index, apps, tex, rank)
	self:Debug("UnitBuffChanged:"..buff)
	if self:isMending( buff ) then
		self:UpdateUnit(unit, true)
	end
end

function GridStatusMending:isMending(buffName)
	return buffName == "Prayer of Mending"
end

function GridStatusMending:UpdateUnit(unitid, ignoreRange)
	local name = UnitName(unitid)

	if not name then return end

	local settings = self.db.profile.alert_MendingStack
	local MendingCount,lifebloomDuration = self:CountHOTs(unitid)

	self:Debug("Count:"..MendingCount)
	if MendingCount == 0 then
		self.core:SendStatusLost(name, "alert_MendingStack")
		self.core:SendStatusLost(name, "alert_MendingDuration")
	else
		local thecolor = settings.color
		if MendingCount == 2 then
			thecolor = settings.color2
		elseif MendingCount == 3 then
			thecolor = settings.color3
		elseif MendingCount == 4 then
			thecolor = settings.color4
		elseif MendingCount == 5 then
			thecolor = settings.color5
		end
		local time = lifebloomDuration
		if settings.gcdMode then
			time = (lifebloomDuration - settings.gcdDelay) / settings.gcdDuration
			if time < 0 then
				time = 0
			end
		end
		self.core:SendStatusGained(name, "alert_MendingDuration",
			settings.priority,
			(settings.range and 40),
			thecolor,
			string.format("%.1f", time),
			lifebloomDuration,
			6 )

		self.core:SendStatusGained(name, "alert_MendingStack",
			settings.priority,
			(settings.range and 40),
			thecolor,
			tostring(MendingCount),
			MendingCount,
			6 )
	end
end